<?php
/**
* Google Sitemap Generator.
* @version SVN $Id$
* @package gsg.org
* @author rg66*
* @license Released under the terms of the GNU General Public License
* @abstract This class represends the required methods of a 3PC Implementations.
* Extend this class and override the method below.
**/
class latestnews{ 
    /**
    * Get the URLS from the 3PC.
    * @return An array of URLResource objects.
    */
    function getURLResources(){ 

	/** ensure this file is being included by a parent file */
	global $mosConfig_offset, $mosConfig_live_site, $mainframe;
	global $database, $gsg_url_changefreq, $gsg_url_priority;

	$type 		= intval( $params->get( 'type', 1 ) );
	$count 		= intval( $params->get( 'count', 5 ) );
	$count 		= intval( $params->get( 'count', 5 ) );
	$catid 		= trim( $params->get( 'catid' ) );
	$secid 		= trim( $params->get( 'secid' ) );
	$show_front	= $params->get( 'show_front', 1 );
	$class_sfx	= $params->get( 'moduleclass_sfx' );

	$now = date( 'Y-m-d H:i:s', time() + $mosConfig_offset * 60 * 60 );

	$access = !$mainframe->getCfg( 'shownoauth' );

	// select between Content Items, Static Content or both
	switch ( $type ) {
		case 2: //Static Content only
			$query = "SELECT a.id, a.title"
			. "\n FROM #__content AS a"
			. "\n WHERE ( a.state = '1' AND a.checked_out = '0' AND a.sectionid = '0' )"
			. "\n AND ( a.publish_up = '0000-00-00 00:00:00' OR a.publish_up <= '". $now ."' )"
			. "\n AND ( a.publish_down = '0000-00-00 00:00:00' OR a.publish_down >= '". $now ."' )"
		    	. ( $access ? "\n AND a.access <= '". $my->gid ."'" : '' )
			. "\n ORDER BY a.created DESC LIMIT $count"
			;
			$database->setQuery( $query );
			$rows = $database->loadObjectList();	
			break;

		case 3: //Both
			$query = "SELECT a.id, a.title, a.sectionid"
			. "\n FROM #__content AS a"
			. "\n WHERE ( a.state = '1' AND a.checked_out = '0' )"
			. "\n AND ( a.publish_up = '0000-00-00 00:00:00' OR a.publish_up <= '". $now ."' )"
			. "\n AND ( a.publish_down = '0000-00-00 00:00:00' OR a.publish_down >= '". $now ."' )"
		    	. ( $access ? "\n AND a.access <= '". $my->gid ."'" : '' )
			. "\n ORDER BY a.created DESC LIMIT $count"
			;
			$database->setQuery( $query );
			$rows = $database->loadObjectList();	
			break;
		
		case 1:  //Content Items only
		default:
			$query = "SELECT a.id, a.title, a.sectionid, a.catid"
			. "\n FROM #__content AS a"
			. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
			. "\n WHERE ( a.state = '1' AND a.checked_out = '0' AND a.sectionid > '0' )"
			. "\n AND ( a.publish_up = '0000-00-00 00:00:00' OR a.publish_up <= '". $now ."' )"
			. "\n AND ( a.publish_down = '0000-00-00 00:00:00' OR a.publish_down >= '". $now ."' )"
		    	. ( $access ? "\n AND a.access <= '". $my->gid ."'" : '' )
			. ( $catid ? "\n AND ( a.catid IN (". $catid .") )" : '' )
			. ( $secid ? "\n AND ( a.sectionid IN (". $secid .") )" : '' )
			. ( $show_front == "0" ? "\n AND f.content_id IS NULL" : '' )
			. "\n ORDER BY a.created DESC LIMIT $count"
			;
			$database->setQuery( $query );
			$rows = $database->loadObjectList();
			break;		
	}

	// needed to reduce queries used by getItemid for Content Items
	if ( ( $type == 1 ) || ( $type == 3 ) ) {
		$bs 	= $mainframe->getBlogSectionCount();
		$bc 	= $mainframe->getBlogCategoryCount();
		$gbs 	= $mainframe->getGlobalBlogSectionCount();
	}

	foreach ( $rows as $row ) {
		// get Itemid
		switch ( $type ) {
			case 2:
				$query = "SELECT id"
				. "\n FROM #__menu"
				. "\n WHERE type = 'content_typed'"
				. "\n AND componentid = $row->id"
				;
				$database->setQuery( $query );	
				$Itemid = $database->loadResult();
				break;
			
			case 3:
				if ( $row->sectionid ) {
					$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
				} else {
					$query = "SELECT id"
					. "\n FROM #__menu"
					. "\n WHERE type = 'content_typed'"
					. "\n AND componentid = $row->id"
					;
					$database->setQuery( $query );	
					$Itemid = $database->loadResult();				
				}
				break;

			case 1:
			default:
				$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
				break;
		}
	
		// Blank itemid checker for SEF
		if ($Itemid == NULL) {
			$Itemid = '';
		} else {
			$Itemid = '&amp;Itemid='. $Itemid;
		}
	
		$link = 'index.php?option=com_content&amp;task=view&amp;id='. $row->id . $Itemid ;

		//create a new object on the stack
		$urlResource = new URLResource();

		//assign all variables
		$urlResource->title = $row->title;
		$urlResource->link = $link;
		$urlResource->date = gsg :: showdate(0, 0, 1);
		$urlResource->changeFreq = $gsg_url_changefreq;
		$urlResource->priority = $gsg_url_priority;

		//add the pointer to the array
		$results[] = $urlResource;
	}
	return $results;   
    }	
	    /**
     * @return The string description
     */
    function getDescription(){
    	return "The plugin that will generate URLs from the Latest News Module";
    }
}
?>