<?php

/**
* Google Sitemap Generator.
* @version SVN $Id$
* @package gsg.org
* @author rg66*
* @license Released under the terms of the GNU General Public License
* @abstract This class represends the required methods of a 3PC Implementations.
* Extend this class and override the method below.
**/
class rss extends GSGExtension{

	/**
	* Get the URLS from the 3PC.
	* @return An array of URLResource objects.
	*/
	function getURLResources() {
		global $database, $mosConfig_live_site, $mosConfig_absolute_path, $cur_template;
		global $gsg_menus, $gsg_url_changefreq, $gsg_url_priority;

		require_once ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.class.php");
		$query = "SELECT params "." FROM #__module "." WHERE published = 1 "." AND module = 'mod_rssfeed'";

		$database->setQuery($query);
		$params = & new mosParameters($database->loadResult());

		//echo "params: ".$params->get( 'rss091', 1 )."<br>";

		$text = $params->get('text');
		$moduleclass_sfx = $params->get('moduleclass_sfx', '');
		$rss091 = $params->get('rss091', 1);
		$rss10 = $params->get('rss10', 1);
		$rss20 = $params->get('rss20', 1);
		$atom = $params->get('atom', 1);
		$opml = $params->get('opml', 1);

		// rss091 link
		if ($rss091) {
			//create a new object on the stack
			$urlResource = new URLResource();

			//assign all variables
			$urlResource->title = "RSS091";
			$urlResource->link = "index.php?option=com_rss&amp;feed=RSS0.91&amp;no_html=1";
			$urlResource->date = gsg :: showdate(0, 0, 1);
			$urlResource->changeFreq = $gsg_url_changefreq;
			$urlResource->priority = $gsg_url_priority;

			//add the pointer to the array
			$results[] = $urlResource;
		}

		// rss10 link
		if ($rss10) {
			//create a new object on the stack
			$urlResource = new URLResource();

			//assign all variables
			$urlResource->title = "RSS10";
			$urlResource->link = "index.php?option=com_rss&amp;feed=RSS1.0&amp;no_html=1";
			$urlResource->date = gsg :: showdate(0, 0, 1);
			$urlResource->changeFreq = $gsg_url_changefreq;
			$urlResource->priority = $gsg_url_priority;

			//add the pointer to the array
			$results[] = $urlResource;
		}

		// rss20 link
		if ($rss20) {
			//create a new object on the stack
			$urlResource = new URLResource();

			//assign all variables
			$urlResource->title = "RSS20";
			$urlResource->link = "index.php?option=com_rss&amp;feed=RSS2.0&amp;no_html=1";
			$urlResource->date = gsg :: showdate(0, 0, 1);
			$urlResource->changeFreq = $gsg_url_changefreq;
			$urlResource->priority = $gsg_url_priority;

			//add the pointer to the array
			$results[] = $urlResource;
		}

		// atom link
		if ($atom) {
			//create a new object on the stack
			$urlResource = new URLResource();

			//assign all variables
			$urlResource->title = "ATOM0.3";
			$urlResource->link = "index.php?option=com_rss&amp;feed=ATOM0.3&amp;no_html=1";
			$urlResource->date = gsg :: showdate(0, 0, 1);
			$urlResource->changeFreq = $gsg_url_changefreq;
			$urlResource->priority = $gsg_url_priority;

			//add the pointer to the array
			$results[] = $urlResource;
		}

		// opml link
		if ($opml) {
			//create a new object on the stack
			$urlResource = new URLResource();

			//assign all variables
			$urlResource->title = "OPML";
			$urlResource->link = "index.php?option=com_rss&amp;feed=OPML&amp;no_html=1";
			$urlResource->date = gsg :: showdate(0, 0, 1);
			$urlResource->changeFreq = $gsg_url_changefreq;
			$urlResource->priority = $gsg_url_priority;

			//add the pointer to the array
			$results[] = $urlResource;
		}
		//echo "rss:".count($results)."<br>";
		return $results;
	}

	/**
	 * @return The string description
	 */
	function getDescription() {
		return "The plugin that will generate URLs from the rss feeds";
	}
}
?>